## mingw-w64-amgcl-1.4.5-1.src.tar.zst

=== docker/Makefile ===
%: Dockerfile-%
	(cd ../ && docker build . -f ./docker/$^ -t amgcl-$@)

run-%: Dockerfile-%
	docker run --gpus all -ti amgcl-$*
